module divide18 (clk, parallel_load, parallel_in, out);
input        clk; 
input        parallel_load;  // assert for parallel load
input  [4:0] parallel_in;
output       out;            // one pulse every 18 clk cycles
reg    [4:0] tmp;
wire         reset;

  always @(posedge clk)
  begin
    if (reset) begin
      tmp <= 0;
    end
    else if (parallel_load) begin
      tmp <= parallel_in;
    end
    else begin
      tmp <= tmp + 1;
    end
    
  end
  
  assign out   = (tmp == 0);
  assign reset = (tmp == 17);
endmodule
