module transmit_tb;
reg        rst;
reg        clk;
reg        tx;
reg        fs;
wire       dtx;
reg  [7:0] txdata, rxdata, data, pass;

initial begin
  $dumpfile ("transmit_tb.vcd");
  $dumpvars (1, my_transmit);
  $dumpvars (2, my_transmit.my_txuart);
  $dumpvars (3, my_transmit.my_doublebuf);

  pass = 0;
  tx = 1;
  fs = 0;
  rst = 1;
  #1 clk = 1;
  #1 clk = 0;
  rst = 0;
  #1 clk = 1;
  #1 clk = 0;

  //----- Send a 10 bit RS232 Word ----------------*/

  // send start bit

  tx = 0;
  // Note: each 155,000 baud RS232 bit is 18 2.048MHz clk cycles 
  repeat (18) begin 
    #1  clk = 1;
    #1  clk = 0;  
  end

  // send data

  txdata = 8'b11000001;
  data = txdata;
  repeat (8) begin
    tx = data[7];
    repeat (18) begin
      #1  clk = 1;
      #1  clk = 0;  
    end
    data = { data[6:0], 1'b0 };
  end

  // send stop bit
  tx = 1;
  repeat (18) begin
    #1  clk = 1;
    #1  clk = 0;  
  end

  // Output 8 bit TDM word

  #1  clk = 1;
  fs = 1;
  #1  clk = 0;  
  #1  clk = 1;
  fs = 0;
  repeat (7) begin
    #1  clk = 0;  
    #1  clk = 1;
  end
  #1  clk = 0;  
  #1  clk = 1;
  
end

transmit my_transmit(
.rst      (rst),
.clk      (clk),
.tx       (tx),
.fs       (fs),
.dtx      (dtx)
);

endmodule

